<?php

/**
 * @file
 * Provide views data and handlers for rpx_ui.module
 */

/**
 * Implements hook_views_data().
 */
function rpx_ui_views_data() {
  $data['rpx_linked_account']['table']['group']  = t('Janrain Engage');

  $data['rpx_linked_account']['table']['join'] = array(
    // Links to users (base) table via authmap table.
    'users' => array(
      'left_table' => 'authmap',
      'left_field' => 'aid',
      'field' => 'aid',
    ),
    // Links to node (base) table via authmap table.
    'node' => array(
      'left_table' => 'authmap',
      'left_field' => 'aid',
      'field' => 'aid',
    ),
  );

  $data['rpx_linked_account']['provider_name'] = array(
    'title' => t('Provider machine name'),
    'help' => t('3rd party identity provider\'s name for linked account.'),
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['rpx_linked_account']['provider_title'] = array(
    'title' => t('Provider title'),
    'help' => t('3rd party identity provider\'s title for linked account.'),
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['rpx_linked_account']['provider_icon'] = array(
    'title' => t('Provider icon'),
    'help' => t('3rd party identity provider\'s icon.'),
    'real field' => 'provider_name',
    'field' => array(
      'handler' => 'rpx_ui_handler_field_provider_icon',
    ),
  );

  $data['authmap']['linked_account'] = array(
    'group' => t('Janrain Engage'),
    'title' => t('Linked account ID'),
    'help' => t('ID returned by Engage for user\'s 3rd party account.'),
    'real field' => 'authname',
    'field' => array(
      'handler' => 'views_handler_field',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['authmap']['delete_link'] = array(
    'group' => t('Janrain Engage'),
    'title' => t('Delete linked account'),
    'help' => t('Displays a link to delete linked account.'),
    'real field' => 'aid',
    'field' => array(
      'handler' => 'rpx_ui_handler_field_delete_link',
    ),
  );

  return $data;
}

